rpmpgp.h File Reference

OpenPGP constants and structures from RFC-2440. More...

`#include <string.h>`
`#include <stdio.h>`
`#include <stdlib.h>`
`#include <rpm/rpmtypes.h>`
`#include <rpm/rpmstring.h>`
Include dependency graph for rpmpgp.h:

Go to the source code of this file.

## Data Structures

struct | pgpPktPubkey_s
| 5.1. More...
struct | pgpPktSigV3_s
| 5.2.2. More...
struct | pgpPktSigV4_s
| 5.2.3. More...
union | pgpPktSig_u
| 5.2. More...
struct | pgpPktSymkey_s
| 5.3. More...
struct | pgpPktOnepass_s
| 5.4. More...
struct | pgpPktKeyV3_s
| 5.5.1. More...
struct | pgpPktKeyV4_s
| The version 4 format is similar to the version 3 format except for the absence of a validity period. More...
union | pgpPktKey_u
| 5.5.3. More...
struct | pgpPktCdata_s
struct | pgpPktEdata_s
struct | pgpPktLdata_s
struct | pgpPktTrust_s
struct | pgpPktUid_s
union | pgpPktPre_u

## Macros

#define | PGPARMOR_ERROR PGPARMOR_ERR_NO_BEGIN_PGP

## Typedefs

typedef struct DIGEST_CTX_s * | DIGEST_CTX
typedef struct rpmDigestBundle_s * | rpmDigestBundle
typedef struct pgpDig_s * | pgpDig
typedef struct pgpDigParams_s * | pgpDigParams
typedef uint8_t | pgpKeyID_t[8]
typedef uint8_t | pgpTime_t[4]
typedef enum pgpTag_e | pgpTag
| 4.3. More...
typedef struct pgpPktPubkey_s | pgpPktPubkey
| 5.1. More...
typedef enum pgpSigType_e | pgpSigType
| 5.2.1. More...
typedef enum pgpPubkeyAlgo_e | pgpPubkeyAlgo
| 9.1. More...
typedef enum pgpSymkeyAlgo_e | pgpSymkeyAlgo
| 9.2. More...
typedef enum pgpCompressAlgo_e | pgpCompressAlgo
| 9.3. More...
typedef enum pgpHashAlgo_e | pgpHashAlgo
| 9.4. More...
typedef struct pgpPktSigV3_s * | pgpPktSigV3
| 5.2.2. More...
typedef struct pgpPktSigV4_s * | pgpPktSigV4
| 5.2.3. More...
typedef enum pgpSubType_e | pgpSubType
| 5.2.3.1. More...
typedef union pgpPktSig_u * | pgpPktSig
| 5.2. More...
typedef struct pgpPktSymkey_s | pgpPktSymkey
| 5.3. More...
typedef struct pgpPktOnepass_s * | pgpPktOnepass
| 5.4. More...
typedef struct pgpPktKeyV3_s * | pgpPktKeyV3
| 5.5.1. More...
typedef struct pgpPktKeyV4_s * | pgpPktKeyV4
| The version 4 format is similar to the version 3 format except for the absence of a validity period. More...
typedef union pgpPktKey_u | pgpPktKey
| 5.5.3. More...
typedef struct pgpPktCdata_s | pgpPktCdata
typedef struct pgpPktEdata_s | pgpPktEdata
typedef struct pgpPktLdata_s | pgpPktLdata
typedef struct pgpPktTrust_s | pgpPktTrust
typedef struct pgpPktUid_s | pgpPktUid
typedef enum pgpArmor_e | pgpArmor
typedef enum pgpArmorKey_e | pgpArmorKey
typedef enum pgpValType_e | pgpValType
typedef rpmFlags | rpmDigestFlags

## Enumerations

enum

pgpTag_e {
PGPTAG_RESERVED = 0, PGPTAG_PUBLIC_SESSION_KEY = 1, PGPTAG_SIGNATURE = 2, PGPTAG_SYMMETRIC_SESSION_KEY = 3,
PGPTAG_ONEPASS_SIGNATURE = 4, PGPTAG_SECRET_KEY = 5, PGPTAG_PUBLIC_KEY = 6, PGPTAG_SECRET_SUBKEY = 7,
PGPTAG_COMPRESSED_DATA = 8, PGPTAG_SYMMETRIC_DATA = 9, PGPTAG_MARKER = 10, PGPTAG_LITERAL_DATA = 11,
PGPTAG_TRUST = 12, PGPTAG_USER_ID = 13, PGPTAG_PUBLIC_SUBKEY = 14, PGPTAG_COMMENT_OLD = 16,
PGPTAG_PHOTOID = 17, PGPTAG_ENCRYPTED_MDC = 18, PGPTAG_MDC = 19, PGPTAG_PRIVATE_60 = 60,
PGPTAG_COMMENT = 61, PGPTAG_PRIVATE_62 = 62, PGPTAG_CONTROL = 63
}

| 4.3. More...

enum

pgpSigType_e {
PGPSIGTYPE_BINARY = 0x00, PGPSIGTYPE_TEXT = 0x01, PGPSIGTYPE_STANDALONE = 0x02, PGPSIGTYPE_GENERIC_CERT = 0x10,
PGPSIGTYPE_PERSONA_CERT = 0x11, PGPSIGTYPE_CASUAL_CERT = 0x12, PGPSIGTYPE_POSITIVE_CERT = 0x13, PGPSIGTYPE_SUBKEY_BINDING = 0x18,
PGPSIGTYPE_SIGNED_KEY = 0x1F, PGPSIGTYPE_KEY_REVOKE = 0x20, PGPSIGTYPE_SUBKEY_REVOKE = 0x28, PGPSIGTYPE_CERT_REVOKE = 0x30,
PGPSIGTYPE_TIMESTAMP = 0x40
}

| 5.2.1. More...
enum | pgpPubkeyAlgo_e { PGPPUBKEYALGO_RSA = 1, PGPPUBKEYALGO_RSA_ENCRYPT = 2, PGPPUBKEYALGO_RSA_SIGN = 3, PGPPUBKEYALGO_ELGAMAL_ENCRYPT = 16, PGPPUBKEYALGO_DSA = 17, PGPPUBKEYALGO_EC = 18, PGPPUBKEYALGO_ECDSA = 19, PGPPUBKEYALGO_ELGAMAL = 20, PGPPUBKEYALGO_DH = 21 }
| 9.1. More...
enum | pgpSymkeyAlgo_e { PGPSYMKEYALGO_PLAINTEXT = 0, PGPSYMKEYALGO_IDEA = 1, PGPSYMKEYALGO_TRIPLE_DES = 2, PGPSYMKEYALGO_CAST5 = 3, PGPSYMKEYALGO_BLOWFISH = 4, PGPSYMKEYALGO_SAFER = 5, PGPSYMKEYALGO_DES_SK = 6, PGPSYMKEYALGO_AES_128 = 7, PGPSYMKEYALGO_AES_192 = 8, PGPSYMKEYALGO_AES_256 = 9, PGPSYMKEYALGO_TWOFISH = 10, PGPSYMKEYALGO_NOENCRYPT = 110 }
| 9.2. More...
enum | pgpCompressAlgo_e { PGPCOMPRESSALGO_NONE = 0, PGPCOMPRESSALGO_ZIP = 1, PGPCOMPRESSALGO_ZLIB = 2, PGPCOMPRESSALGO_BZIP2 = 3 }
| 9.3. More...
enum | pgpHashAlgo_e { PGPHASHALGO_MD5 = 1, PGPHASHALGO_SHA1 = 2, PGPHASHALGO_RIPEMD160 = 3, PGPHASHALGO_MD2 = 5, PGPHASHALGO_TIGER192 = 6, PGPHASHALGO_HAVAL_5_160 = 7, PGPHASHALGO_SHA256 = 8, PGPHASHALGO_SHA384 = 9, PGPHASHALGO_SHA512 = 10, PGPHASHALGO_SHA224 = 11 }
| 9.4. More...

enum

pgpSubType_e {
PGPSUBTYPE_NONE = 0, PGPSUBTYPE_SIG_CREATE_TIME = 2, PGPSUBTYPE_SIG_EXPIRE_TIME = 3, PGPSUBTYPE_EXPORTABLE_CERT = 4,
PGPSUBTYPE_TRUST_SIG = 5, PGPSUBTYPE_REGEX = 6, PGPSUBTYPE_REVOCABLE = 7, PGPSUBTYPE_KEY_EXPIRE_TIME = 9,
PGPSUBTYPE_ARR = 10, PGPSUBTYPE_PREFER_SYMKEY = 11, PGPSUBTYPE_REVOKE_KEY = 12, PGPSUBTYPE_ISSUER_KEYID = 16,
PGPSUBTYPE_NOTATION = 20, PGPSUBTYPE_PREFER_HASH = 21, PGPSUBTYPE_PREFER_COMPRESS = 22, PGPSUBTYPE_KEYSERVER_PREFERS = 23,
PGPSUBTYPE_PREFER_KEYSERVER = 24, PGPSUBTYPE_PRIMARY_USERID = 25, PGPSUBTYPE_POLICY_URL = 26, PGPSUBTYPE_KEY_FLAGS = 27,
PGPSUBTYPE_SIGNER_USERID = 28, PGPSUBTYPE_REVOKE_REASON = 29, PGPSUBTYPE_FEATURES = 30, PGPSUBTYPE_EMBEDDED_SIG = 32,
PGPSUBTYPE_INTERNAL_100 = 100, PGPSUBTYPE_INTERNAL_101 = 101, PGPSUBTYPE_INTERNAL_102 = 102, PGPSUBTYPE_INTERNAL_103 = 103,
PGPSUBTYPE_INTERNAL_104 = 104, PGPSUBTYPE_INTERNAL_105 = 105, PGPSUBTYPE_INTERNAL_106 = 106, PGPSUBTYPE_INTERNAL_107 = 107,
PGPSUBTYPE_INTERNAL_108 = 108, PGPSUBTYPE_INTERNAL_109 = 109, PGPSUBTYPE_INTERNAL_110 = 110, PGPSUBTYPE_CRITICAL = 128
}

| 5.2.3.1. More...

enum

pgpArmor_e {
PGPARMOR_ERR_CRC_CHECK = -7, PGPARMOR_ERR_BODY_DECODE = -6, PGPARMOR_ERR_CRC_DECODE = -5, PGPARMOR_ERR_NO_END_PGP = -4,
PGPARMOR_ERR_UNKNOWN_PREAMBLE_TAG = -3, PGPARMOR_ERR_UNKNOWN_ARMOR_TYPE = -2, PGPARMOR_ERR_NO_BEGIN_PGP = -1, PGPARMOR_NONE = 0,
PGPARMOR_MESSAGE = 1, PGPARMOR_PUBKEY = 2, PGPARMOR_SIGNATURE = 3, PGPARMOR_SIGNED_MESSAGE = 4,
PGPARMOR_FILE = 5, PGPARMOR_PRIVKEY = 6, PGPARMOR_SECKEY = 7
}

enum | pgpArmorKey_e { PGPARMORKEY_VERSION = 1, PGPARMORKEY_COMMENT = 2, PGPARMORKEY_MESSAGEID = 3, PGPARMORKEY_HASH = 4, PGPARMORKEY_CHARSET = 5 }
enum | pgpValType_e { PGPVAL_TAG = 1, PGPVAL_ARMORBLOCK = 2, PGPVAL_ARMORKEY = 3, PGPVAL_SIGTYPE = 4, PGPVAL_SUBTYPE = 5, PGPVAL_PUBKEYALGO = 6, PGPVAL_SYMKEYALGO = 7, PGPVAL_COMPRESSALGO = 8, PGPVAL_HASHALGO = 9, PGPVAL_SERVERPREFS = 10 }
enum | rpmDigestFlags_e { RPMDIGEST_NONE = 0 }
| Bit(s) to control digest operation. More...

## Functions

const char * | pgpValString (pgpValType type, uint8_t val)
| Return string representation of am OpenPGP value. More...
static unsigned int | pgpGrab (const uint8_t *s, size_t nbytes)
| Return (native-endian) integer from big-endian representation. More...
char * | pgpHexStr (const uint8_t *p, size_t plen)
| Return hex formatted representation of bytes. More...
int | pgpPubkeyFingerprint (const uint8_t *pkt, size_t pktlen, pgpKeyID_t keyid)
| Calculate OpenPGP public key fingerprint. More...
int | pgpExtractPubkeyFingerprint (const char *b64pkt, pgpKeyID_t keyid)
| Extract OpenPGP public key fingerprint from base64 encoded packet. More...
int | pgpPrtParams (const uint8_t *pkts, size_t pktlen, unsigned int pkttype, pgpDigParams *ret)
| Parse a OpenPGP packet(s). More...
int | pgpPrtParamsSubkeys (const uint8_t *pkts, size_t pktlen, pgpDigParams mainkey, pgpDigParams **subkeys, int *subkeysCount)
| Parse subkey parameters from OpenPGP packet(s). More...
int | pgpPrtPkts (const uint8_t *pkts, size_t pktlen, pgpDig dig, int printing)
| Print/parse a OpenPGP packet(s). More...
pgpArmor | pgpReadPkts (const char *fn, uint8_t **pkt, size_t *pktlen)
| Parse armored OpenPGP packets from a file. More...
pgpArmor | pgpParsePkts (const char *armor, uint8_t **pkt, size_t *pktlen)
| Parse armored OpenPGP packets from memory. More...
int | pgpPubKeyCertLen (const uint8_t *pkts, size_t pktslen, size_t *certlen)
| Return a length of the first public key certificate in a buffer given by pkts that contains one or more certificates. More...
char * | pgpArmorWrap (int atype, const unsigned char *s, size_t ns)
| Wrap a OpenPGP packets in ascii armor for transport. More...
pgpDig | pgpNewDig (void)
| Create a container for parsed OpenPGP packet(s). More...
void | pgpCleanDig (pgpDig dig)
| Release (malloc'd) data from container. More...
pgpDig | pgpFreeDig (pgpDig dig)
| Destroy a container for parsed OpenPGP packet(s). More...
pgpDigParams | pgpDigGetParams (pgpDig dig, unsigned int pkttype)
| Retrieve parameters for parsed OpenPGP packet(s). More...
int | pgpDigParamsCmp (pgpDigParams p1, pgpDigParams p2)
| Compare OpenPGP packet parameters param p1 1st parameter container param p2 2nd parameter container return 1 if the parameters differ, 0 otherwise. More...
unsigned int | pgpDigParamsAlgo (pgpDigParams digp, unsigned int algotype)
| Retrieve OpenPGP algorithm parameters param digp parameter container param algotype PGPVAL_HASHALGO / PGPVAL_PUBKEYALGO return algorithm value, 0 on error. More...
pgpDigParams | pgpDigParamsFree (pgpDigParams digp)
| Destroy parsed OpenPGP packet parameter(s). More...
rpmRC | pgpVerifySignature (pgpDigParams key, pgpDigParams sig, DIGEST_CTX hashctx)
| Verify a PGP signature. More...
rpmRC | pgpVerifySig (pgpDig dig, DIGEST_CTX hashctx)
| Verify a PGP signature. More...
char * | pgpIdentItem (pgpDigParams digp)
| Return a string identification of a PGP signature/pubkey. More...
int | rpmInitCrypto (void)
| Perform cryptography initialization. More...
int | rpmFreeCrypto (void)
| Shutdown cryptography. More...
DIGEST_CTX | rpmDigestDup (DIGEST_CTX octx)
| Duplicate a digest context. More...
size_t | rpmDigestLength (int hashalgo)
| Obtain digest length in bytes. More...
DIGEST_CTX | rpmDigestInit (int hashalgo, rpmDigestFlags flags)
| Initialize digest. More...
int | rpmDigestUpdate (DIGEST_CTX ctx, const void *data, size_t len)
| Update context with next plain text buffer. More...
int | rpmDigestFinal (DIGEST_CTX ctx, void **datap, size_t *lenp, int asAscii)
| Return digest and destroy context. More...
rpmDigestBundle | rpmDigestBundleNew (void)
| Create a new digest bundle. More...
rpmDigestBundle | rpmDigestBundleFree (rpmDigestBundle bundle)
| Free a digest bundle and all contained digest contexts. More...
int | rpmDigestBundleAdd (rpmDigestBundle bundle, int algo, rpmDigestFlags flags)
| Add a new type of digest to a bundle. More...
int | rpmDigestBundleUpdate (rpmDigestBundle bundle, const void *data, size_t len)
| Update contexts within bundle with next plain text buffer. More...
int | rpmDigestBundleFinal (rpmDigestBundle bundle, int algo, void **datap, size_t *lenp, int asAscii)
| Return digest from a bundle and destroy context, see rpmDigestFinal(). More...
DIGEST_CTX | rpmDigestBundleDupCtx (rpmDigestBundle bundle, int algo)
| Duplicate a digest context from a bundle. More...

## Detailed Description

OpenPGP constants and structures from RFC-2440.

Text from RFC-2440 in comments is Copyright (C) The Internet Society (1998). All Rights Reserved.

Definition in file rpmpgp.h.

## Macro Definition Documentation

#define PGPARMOR_ERROR PGPARMOR_ERR_NO_BEGIN_PGP

Definition at line 896 of file rpmpgp.h.

## Typedef Documentation

typedef struct DIGEST_CTX_s* DIGEST_CTX

Definition at line 25 of file rpmpgp.h.

typedef enum pgpArmor_e pgpArmor

typedef enum pgpArmorKey_e pgpArmorKey

typedef enum pgpCompressAlgo_e pgpCompressAlgo

9.3.

Compression Algorithms

           ID           Algorithm
           --           ---------
           0          - Uncompressed
           1          - ZIP (RFC 1951)
           2          - ZLIB (RFC 1950)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement uncompressed data. Implementations SHOULD implement ZIP. Implementations MAY implement ZLIB.

typedef struct pgpDig_s* pgpDig

Definition at line 30 of file rpmpgp.h.

typedef struct pgpDigParams_s* pgpDigParams

Definition at line 34 of file rpmpgp.h.

typedef enum pgpHashAlgo_e pgpHashAlgo

9.4.

Hash Algorithms

           ID           Algorithm                              Text Name
           --           ---------                              ---- ----
           1          - MD5                                    "MD5"
           2          - SHA-1                                  "SHA1"
           3          - RIPE-MD/160                            "RIPEMD160"
           4          - Reserved for double-width SHA (experimental)
           5          - MD2                                    "MD2"
           6          - Reserved for TIGER/192                 "TIGER192"
           7          - Reserved for HAVAL (5 pass, 160-bit)
           "HAVAL-5-160"
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement SHA-1. Implementations SHOULD implement MD5.

Todo:
  Add SHA256.

typedef uint8_t pgpKeyID_t[8]

Definition at line 36 of file rpmpgp.h.

typedef struct pgpPktCdata_s pgpPktCdata

typedef struct pgpPktEdata_s pgpPktEdata

typedef union pgpPktKey_u pgpPktKey

5.5.3.

Secret Key Packet Formats

The Secret Key and Secret Subkey packets contain all the data of the Public Key and Public Subkey packets, with additional algorithm- specific secret key data appended, in encrypted form.

The packet contains:

- A Public Key or Public Subkey packet, as described above
- One octet indicating string-to-key usage conventions. 0 indicates that the secret key data is not encrypted. 255 indicates that a string-to-key specifier is being given. Any other value is a symmetric-key encryption algorithm specifier.
- [Optional] If string-to-key usage octet was 255, a one-octet symmetric encryption algorithm.
- [Optional] If string-to-key usage octet was 255, a string-to-key specifier. The length of the string-to-key specifier is implied by its type, as described above.
- [Optional] If secret data is encrypted, eight-octet Initial Vector (IV).
- Encrypted multi-precision integers comprising the secret key data. These algorithm-specific fields are as described below.

- Two-octet checksum of the plaintext of the algorithm-specific portion (sum of all octets, mod 65536).

  Algorithm Specific Fields for RSA secret keys:

  - multiprecision integer (MPI) of RSA secret exponent d.
  - MPI of RSA secret prime value p.
  - MPI of RSA secret prime value q (p < q).
  - MPI of u, the multiplicative inverse of p, mod q.

  Algorithm Specific Fields for DSA secret keys:

  - MPI of DSA secret exponent x.

  Algorithm Specific Fields for Elgamal secret keys:

  - MPI of Elgamal secret exponent x.

Secret MPI values can be encrypted using a passphrase. If a string- to-key specifier is given, that describes the algorithm for converting the passphrase to a key, else a simple MD5 hash of the passphrase is used. Implementations SHOULD use a string-to-key specifier; the simple hash is for backward compatibility. The cipher for encrypting the MPIs is specified in the secret key packet.

Encryption/decryption of the secret data is done in CFB mode using the key created from the passphrase and the Initial Vector from the packet. A different mode is used with V3 keys (which are only RSA) than with other key formats. With V3 keys, the MPI bit count prefix (i.e., the first two octets) is not encrypted. Only the MPI non- prefix data is encrypted. Furthermore, the CFB state is resynchronized at the beginning of each new MPI value, so that the CFB block boundary is aligned with the start of the MPI data.

With V4 keys, a simpler method is used. All secret MPI values are encrypted in CFB mode, including the MPI bitcount prefix.

The 16-bit checksum that follows the algorithm-specific portion is the algebraic sum, mod 65536, of the plaintext of all the algorithm- specific octets (including MPI prefix and data). With V3 keys, the checksum is stored in the clear. With V4 keys, the checksum is encrypted like the algorithm-specific data. This value is used to check that the passphrase was correct.

typedef struct pgpPktKeyV3_s * pgpPktKeyV3

5.5.1.

Key Packet Variants

5.5.1.1. Public Key Packet (Tag 6)

A Public Key packet starts a series of packets that forms an OpenPGP key (sometimes called an OpenPGP certificate).

5.5.1.2. Public Subkey Packet (Tag 14)

A Public Subkey packet (tag 14) has exactly the same format as a Public Key packet, but denotes a subkey. One or more subkeys may be associated with a top-level key. By convention, the top-level key provides signature services, and the subkeys provide encryption services.

Note: in PGP 2.6.x, tag 14 was intended to indicate a comment packet. This tag was selected for reuse because no previous version of PGP ever emitted comment packets but they did properly ignore them. Public Subkey packets are ignored by PGP 2.6.x and do not cause it to fail, providing a limited degree of backward compatibility.

5.5.1.3. Secret Key Packet (Tag 5)

A Secret Key packet contains all the information that is found in a Public Key packet, including the public key material, but also includes the secret key material after all the public key fields.

5.5.1.4. Secret Subkey Packet (Tag 7)

A Secret Subkey packet (tag 7) is the subkey analog of the Secret Key packet, and has exactly the same format.

5.5.2. Public Key Packet Formats

There are two versions of key-material packets. Version 3 packets were first generated by PGP 2.6. Version 2 packets are identical in format to Version 3 packets, but are generated by PGP 2.5 or before. V2 packets are deprecated and they MUST NOT be generated. PGP 5.0 introduced version 4 packets, with new fields and semantics. PGP 2.6.x will not accept key-material packets with versions greater than 3.

OpenPGP implementations SHOULD create keys with version 4 format. An implementation MAY generate a V3 key to ensure interoperability with old software; note, however, that V4 keys correct some security deficiencies in V3 keys. These deficiencies are described below. An implementation MUST NOT create a V3 key with a public key algorithm other than RSA.

A version 3 public key or public subkey packet contains:

- A one-octet version number (3).
- A four-octet number denoting the time that the key was created.
- A two-octet number denoting the time in days that this key is valid. If this number is zero, then it does not expire.
- A one-octet number denoting the public key algorithm of this key
- A series of multi-precision integers comprising the key material:
  - a multiprecision integer (MPI) of RSA public modulus n;
  - an MPI of RSA public encryption exponent e.

V3 keys SHOULD only be used for backward compatibility because of three weaknesses in them. First, it is relatively easy to construct a V3 key that has the same key ID as any other key because the key ID is simply the low 64 bits of the public modulus. Secondly, because the fingerprint of a V3 key hashes the key material, but not its length, which increases the opportunity for fingerprint collisions. Third, there are minor weaknesses in the MD5 hash algorithm that make developers prefer other algorithms. See below for a fuller discussion of key IDs and fingerprints.

typedef struct pgpPktKeyV4_s * pgpPktKeyV4

The version 4 format is similar to the version 3 format except for the absence of a validity period.

This has been moved to the signature packet. In addition, fingerprints of version 4 keys are calculated differently from version 3 keys, as described in section "Enhanced Key Formats."

A version 4 packet contains:

- A one-octet version number (4).
- A four-octet number denoting the time that the key was created.
- A one-octet number denoting the public key algorithm of this key

- A series of multi-precision integers comprising the key material. This algorithm-specific portion is:

  Algorithm Specific Fields for RSA public keys:

  - multiprecision integer (MPI) of RSA public modulus n;
  - MPI of RSA public encryption exponent e.

  Algorithm Specific Fields for DSA public keys:

  - MPI of DSA prime p;
  - MPI of DSA group order q (q is a prime divisor of p-1);
  - MPI of DSA group generator g;
  - MPI of DSA public key value y (= g**x where x is secret).

  Algorithm Specific Fields for Elgamal public keys:

  - MPI of Elgamal prime p;
  - MPI of Elgamal group generator g;
  - MPI of Elgamal public key value y (= g**x where x is secret).

typedef struct pgpPktLdata_s pgpPktLdata

typedef struct pgpPktOnepass_s * pgpPktOnepass

5.4.

One-Pass Signature Packets (Tag 4)

The One-Pass Signature packet precedes the signed data and contains enough information to allow the receiver to begin calculating any hashes needed to verify the signature. It allows the Signature Packet to be placed at the end of the message, so that the signer can compute the entire signed message in one pass.

A One-Pass Signature does not interoperate with PGP 2.6.x or earlier.

The body of this packet consists of:

- A one-octet version number. The current version is 3.
- A one-octet signature type. Signature types are described in section 5.2.1.
- A one-octet number describing the hash algorithm used.
- A one-octet number describing the public key algorithm used.
- An eight-octet number holding the key ID of the signing key.
- A one-octet number holding a flag showing whether the signature is nested. A zero value indicates that the next packet is another One-Pass Signature packet that describes another signature to be applied to the same message data.

Note that if a message contains more than one one-pass signature, then the signature packets bracket the message; that is, the first signature packet after the message corresponds to the last one-pass packet and the final signature packet corresponds to the first one- pass packet.

typedef struct pgpPktPubkey_s pgpPktPubkey

5.1.

Public-Key Encrypted Session Key Packets (Tag 1)

A Public-Key Encrypted Session Key packet holds the session key used to encrypt a message. Zero or more Encrypted Session Key packets (either Public-Key or Symmetric-Key) may precede a Symmetrically Encrypted Data Packet, which holds an encrypted message. The message is encrypted with the session key, and the session key is itself encrypted and stored in the Encrypted Session Key packet(s). The Symmetrically Encrypted Data Packet is preceded by one Public-Key Encrypted Session Key packet for each OpenPGP key to which the message is encrypted. The recipient of the message finds a session key that is encrypted to their public key, decrypts the session key, and then uses the session key to decrypt the message.

The body of this packet consists of:

- A one-octet number giving the version number of the packet type. The currently defined value for packet version is 3. An implementation should accept, but not generate a version of 2, which is equivalent to V3 in all other respects.
- An eight-octet number that gives the key ID of the public key that the session key is encrypted to.
- A one-octet number giving the public key algorithm used.
- A string of octets that is the encrypted session key. This string takes up the remainder of the packet, and its contents are dependent on the public key algorithm used.

Algorithm Specific Fields for RSA encryption

- multiprecision integer (MPI) of RSA encrypted value m**e mod n.

Algorithm Specific Fields for Elgamal encryption:

- MPI of Elgamal (Diffie-Hellman) value g**k mod p.
- MPI of Elgamal (Diffie-Hellman) value m * y**k mod p.

typedef union pgpPktSig_u * pgpPktSig

5.2.

Signature Packet (Tag 2)

A signature packet describes a binding between some public key and some data. The most common signatures are a signature of a file or a block of text, and a signature that is a certification of a user ID.

Two versions of signature packets are defined. Version 3 provides basic signature information, while version 4 provides an expandable format with subpackets that can specify more information about the signature. PGP 2.6.x only accepts version 3 signatures.

Implementations MUST accept V3 signatures. Implementations SHOULD generate V4 signatures. Implementations MAY generate a V3 signature that can be verified by PGP 2.6.x.

Note that if an implementation is creating an encrypted and signed message that is encrypted to a V3 key, it is reasonable to create a V3 signature.

typedef struct pgpPktSigV3_s * pgpPktSigV3

5.2.2.

Version 3 Signature Packet Format

The body of a version 3 Signature Packet contains:

- One-octet version number (3).
- One-octet length of following hashed material. MUST be 5.
  - One-octet signature type.
  - Four-octet creation time.
- Eight-octet key ID of signer.
- One-octet public key algorithm.
- One-octet hash algorithm.
- Two-octet field holding left 16 bits of signed hash value.
- One or more multi-precision integers comprising the signature.

Algorithm Specific Fields for RSA signatures:

- multiprecision integer (MPI) of RSA signature value m**d.

Algorithm Specific Fields for DSA signatures:

- MPI of DSA value r.
- MPI of DSA value s.

typedef struct pgpPktSigV4_s * pgpPktSigV4

5.2.3.

Version 4 Signature Packet Format

The body of a version 4 Signature Packet contains:

- One-octet version number (4).
- One-octet signature type.
- One-octet public key algorithm.
- One-octet hash algorithm.
- Two-octet scalar octet count for following hashed subpacket data. Note that this is the length in octets of all of the hashed subpackets; a pointer incremented by this number will skip over the hashed subpackets.
- Hashed subpacket data. (zero or more subpackets)
- Two-octet scalar octet count for following unhashed subpacket data. Note that this is the length in octets of all of the unhashed subpackets; a pointer incremented by this number will skip over the unhashed subpackets.
- Unhashed subpacket data. (zero or more subpackets)
- Two-octet field holding left 16 bits of signed hash value.
- One or more multi-precision integers comprising the signature.

typedef struct pgpPktSymkey_s pgpPktSymkey

5.3.

Symmetric-Key Encrypted Session-Key Packets (Tag 3)

The Symmetric-Key Encrypted Session Key packet holds the symmetric- key encryption of a session key used to encrypt a message. Zero or more Encrypted Session Key packets and/or Symmetric-Key Encrypted Session Key packets may precede a Symmetrically Encrypted Data Packet that holds an encrypted message. The message is encrypted with a session key, and the session key is itself encrypted and stored in the Encrypted Session Key packet or the Symmetric-Key Encrypted Session Key packet.

If the Symmetrically Encrypted Data Packet is preceded by one or more Symmetric-Key Encrypted Session Key packets, each specifies a passphrase that may be used to decrypt the message. This allows a message to be encrypted to a number of public keys, and also to one or more pass phrases. This packet type is new, and is not generated by PGP 2.x or PGP 5.0.

The body of this packet consists of:

- A one-octet version number. The only currently defined version is 4.
- A one-octet number describing the symmetric algorithm used.
- A string-to-key (S2K) specifier, length as defined above.
- Optionally, the encrypted session key itself, which is decrypted with the string-to-key object.

typedef struct pgpPktTrust_s pgpPktTrust

typedef struct pgpPktUid_s pgpPktUid

typedef enum pgpPubkeyAlgo_e pgpPubkeyAlgo

9.1.

Public Key Algorithms

           ID           Algorithm
           --           ---------
           1          - RSA (Encrypt or Sign)
           2          - RSA Encrypt-Only
           3          - RSA Sign-Only
           16         - Elgamal (Encrypt-Only), see [ELGAMAL]
           17         - DSA (Digital Signature Standard)
           18         - Reserved for Elliptic Curve
           19         - Reserved for ECDSA
           20         - Elgamal (Encrypt or Sign)
           21         - Reserved for Diffie-Hellman (X9.42,
                        as defined for IETF-S/MIME)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement DSA for signatures, and Elgamal for encryption. Implementations SHOULD implement RSA keys. Implementations MAY implement any other algorithm.

typedef enum pgpSigType_e pgpSigType

5.2.1.

Signature Types

There are a number of possible meanings for a signature, which are specified in a signature type octet in any given signature.

typedef enum pgpSubType_e pgpSubType

5.2.3.1.

Signature Subpacket Specification

The subpacket fields consist of zero or more signature subpackets. Each set of subpackets is preceded by a two-octet scalar count of the length of the set of subpackets.

Each subpacket consists of a subpacket header and a body. The header consists of:

- the subpacket length (1, 2, or 5 octets)
- the subpacket type (1 octet) and is followed by the subpacket specific data.

The length includes the type octet but not this length. Its format is similar to the "new" format packet header lengths, but cannot have partial body lengths. That is:

           if the 1st octet <  192, then
               lengthOfLength = 1
               subpacketLen = 1st_octet

           if the 1st octet >= 192 and < 255, then
               lengthOfLength = 2
               subpacketLen = ((1st_octet - 192) << 8) + (2nd_octet) + 192

           if the 1st octet = 255, then
               lengthOfLength = 5
               subpacket length = [four-octet scalar starting at 2nd_octet]

The value of the subpacket type octet may be:

           2 = signature creation time
           3 = signature expiration time
           4 = exportable certification
           5 = trust signature
           6 = regular expression
           7 = revocable
           9 = key expiration time
           10 = placeholder for backward compatibility
           11 = preferred symmetric algorithms
           12 = revocation key
           16 = issuer key ID
           20 = notation data
           21 = preferred hash algorithms
           22 = preferred compression algorithms
           23 = key server preferences
           24 = preferred key server
           25 = primary user id
           26 = policy URL
           27 = key flags
           28 = signer's user id
           29 = reason for revocation
           100 to 110 = internal or user-defined

An implementation SHOULD ignore any subpacket of a type that it does not recognize.

Bit 7 of the subpacket type is the "critical" bit. If set, it denotes that the subpacket is one that is critical for the evaluator of the signature to recognize. If a subpacket is encountered that is marked critical but is unknown to the evaluating software, the evaluator SHOULD consider the signature to be in error.

typedef enum pgpSymkeyAlgo_e pgpSymkeyAlgo

9.2.

Symmetric Key Algorithms

           ID           Algorithm
           --           ---------
           0          - Plaintext or unencrypted data
           1          - IDEA [IDEA]
           2          - Triple-DES (DES-EDE, as per spec -
                        168 bit key derived from 192)
           3          - CAST5 (128 bit key, as per RFC 2144)
           4          - Blowfish (128 bit key, 16 rounds) [BLOWFISH]
           5          - SAFER-SK128 (13 rounds) [SAFER]
           6          - Reserved for DES/SK
           7          - Reserved for AES with 128-bit key
           8          - Reserved for AES with 192-bit key
           9          - Reserved for AES with 256-bit key
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement Triple-DES. Implementations SHOULD implement IDEA and CAST5. Implementations MAY implement any other algorithm.

typedef enum pgpTag_e pgpTag

4.3.

Packet Tags

The packet tag denotes what type of packet the body holds. Note that old format headers can only have tags less than 16, whereas new format headers can have tags as great as 63.

typedef uint8_t pgpTime_t[4]

Definition at line 37 of file rpmpgp.h.

typedef enum pgpValType_e pgpValType

typedef struct rpmDigestBundle_s* rpmDigestBundle

Definition at line 26 of file rpmpgp.h.

typedef rpmFlags rpmDigestFlags

Definition at line 937 of file rpmpgp.h.

## Enumeration Type Documentation

enum pgpArmor_e

Enumerator
PGPARMOR_ERR_CRC_CHECK |
PGPARMOR_ERR_BODY_DECODE |
PGPARMOR_ERR_CRC_DECODE |
PGPARMOR_ERR_NO_END_PGP |
PGPARMOR_ERR_UNKNOWN_PREAMBLE_TAG |
PGPARMOR_ERR_UNKNOWN_ARMOR_TYPE |
PGPARMOR_ERR_NO_BEGIN_PGP |
PGPARMOR_NONE |
PGPARMOR_MESSAGE | MESSAGE
PGPARMOR_PUBKEY | PUBLIC KEY BLOCK
PGPARMOR_SIGNATURE | SIGNATURE
PGPARMOR_SIGNED_MESSAGE | SIGNED MESSAGE
PGPARMOR_FILE | ARMORED FILE
PGPARMOR_PRIVKEY | PRIVATE KEY BLOCK
PGPARMOR_SECKEY | SECRET KEY BLOCK

Definition at line 888 of file rpmpgp.h.

enum pgpArmorKey_e

Enumerator
PGPARMORKEY_VERSION | Version:
PGPARMORKEY_COMMENT | Comment:
PGPARMORKEY_MESSAGEID | MessageID:
PGPARMORKEY_HASH | Hash:
PGPARMORKEY_CHARSET | Charset:

Definition at line 909 of file rpmpgp.h.

enum pgpCompressAlgo_e

9.3.

Compression Algorithms

           ID           Algorithm
           --           ---------
           0          - Uncompressed
           1          - ZIP (RFC 1951)
           2          - ZLIB (RFC 1950)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement uncompressed data. Implementations SHOULD implement ZIP. Implementations MAY implement ZLIB.

Enumerator
PGPCOMPRESSALGO_NONE | Uncompressed
PGPCOMPRESSALGO_ZIP | ZIP
PGPCOMPRESSALGO_ZLIB | ZLIB
PGPCOMPRESSALGO_BZIP2 | BZIP2

Definition at line 228 of file rpmpgp.h.

enum pgpHashAlgo_e

9.4.

Hash Algorithms

           ID           Algorithm                              Text Name
           --           ---------                              ---- ----
           1          - MD5                                    "MD5"
           2          - SHA-1                                  "SHA1"
           3          - RIPE-MD/160                            "RIPEMD160"
           4          - Reserved for double-width SHA (experimental)
           5          - MD2                                    "MD2"
           6          - Reserved for TIGER/192                 "TIGER192"
           7          - Reserved for HAVAL (5 pass, 160-bit)
           "HAVAL-5-160"
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement SHA-1. Implementations SHOULD implement MD5.

Todo:
  Add SHA256.

Enumerator
PGPHASHALGO_MD5 | MD5
PGPHASHALGO_SHA1 | SHA1
PGPHASHALGO_RIPEMD160 | RIPEMD160
PGPHASHALGO_MD2 | MD2
PGPHASHALGO_TIGER192 | TIGER192
PGPHASHALGO_HAVAL_5_160 | HAVAL-5-160
PGPHASHALGO_SHA256 | SHA256
PGPHASHALGO_SHA384 | SHA384
PGPHASHALGO_SHA512 | SHA512
PGPHASHALGO_SHA224 | SHA224

Definition at line 256 of file rpmpgp.h.

enum pgpPubkeyAlgo_e

9.1.

Public Key Algorithms

           ID           Algorithm
           --           ---------
           1          - RSA (Encrypt or Sign)
           2          - RSA Encrypt-Only
           3          - RSA Sign-Only
           16         - Elgamal (Encrypt-Only), see [ELGAMAL]
           17         - DSA (Digital Signature Standard)
           18         - Reserved for Elliptic Curve
           19         - Reserved for ECDSA
           20         - Elgamal (Encrypt or Sign)
           21         - Reserved for Diffie-Hellman (X9.42,
                        as defined for IETF-S/MIME)
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement DSA for signatures, and Elgamal for encryption. Implementations SHOULD implement RSA keys. Implementations MAY implement any other algorithm.

Enumerator
PGPPUBKEYALGO_RSA | RSA
PGPPUBKEYALGO_RSA_ENCRYPT | RSA(Encrypt-Only)
PGPPUBKEYALGO_RSA_SIGN | RSA(Sign-Only)
PGPPUBKEYALGO_ELGAMAL_ENCRYPT | Elgamal(Encrypt-Only)
PGPPUBKEYALGO_DSA | DSA
PGPPUBKEYALGO_EC | Elliptic Curve
PGPPUBKEYALGO_ECDSA | ECDSA
PGPPUBKEYALGO_ELGAMAL | Elgamal
PGPPUBKEYALGO_DH | Diffie-Hellman (X9.42)

Definition at line 162 of file rpmpgp.h.

enum pgpSigType_e

5.2.1.

Signature Types

There are a number of possible meanings for a signature, which are specified in a signature type octet in any given signature.

Enumerator
PGPSIGTYPE_BINARY | Binary document
PGPSIGTYPE_TEXT | Canonical text document
PGPSIGTYPE_STANDALONE | Standalone
PGPSIGTYPE_GENERIC_CERT | Generic certification of a User ID & Public Key
PGPSIGTYPE_PERSONA_CERT | Persona certification of a User ID & Public Key
PGPSIGTYPE_CASUAL_CERT | Casual certification of a User ID & Public Key
PGPSIGTYPE_POSITIVE_CERT | Positive certification of a User ID & Public Key
PGPSIGTYPE_SUBKEY_BINDING | Subkey Binding
PGPSIGTYPE_SIGNED_KEY | Signature directly on a key
PGPSIGTYPE_KEY_REVOKE | Key revocation
PGPSIGTYPE_SUBKEY_REVOKE | Subkey revocation
PGPSIGTYPE_CERT_REVOKE | Certification revocation
PGPSIGTYPE_TIMESTAMP | Timestamp

Definition at line 119 of file rpmpgp.h.

enum pgpSubType_e

5.2.3.1.

Signature Subpacket Specification

The subpacket fields consist of zero or more signature subpackets. Each set of subpackets is preceded by a two-octet scalar count of the length of the set of subpackets.

Each subpacket consists of a subpacket header and a body. The header consists of:

- the subpacket length (1, 2, or 5 octets)
- the subpacket type (1 octet) and is followed by the subpacket specific data.

The length includes the type octet but not this length. Its format is similar to the "new" format packet header lengths, but cannot have partial body lengths. That is:

           if the 1st octet <  192, then
               lengthOfLength = 1
               subpacketLen = 1st_octet

           if the 1st octet >= 192 and < 255, then
               lengthOfLength = 2
               subpacketLen = ((1st_octet - 192) << 8) + (2nd_octet) + 192

           if the 1st octet = 255, then
               lengthOfLength = 5
               subpacket length = [four-octet scalar starting at 2nd_octet]

The value of the subpacket type octet may be:

           2 = signature creation time
           3 = signature expiration time
           4 = exportable certification
           5 = trust signature
           6 = regular expression
           7 = revocable
           9 = key expiration time
           10 = placeholder for backward compatibility
           11 = preferred symmetric algorithms
           12 = revocation key
           16 = issuer key ID
           20 = notation data
           21 = preferred hash algorithms
           22 = preferred compression algorithms
           23 = key server preferences
           24 = preferred key server
           25 = primary user id
           26 = policy URL
           27 = key flags
           28 = signer's user id
           29 = reason for revocation
           100 to 110 = internal or user-defined

An implementation SHOULD ignore any subpacket of a type that it does not recognize.

Bit 7 of the subpacket type is the "critical" bit. If set, it denotes that the subpacket is one that is critical for the evaluator of the signature to recognize. If a subpacket is encountered that is marked critical but is unknown to the evaluating software, the evaluator SHOULD consider the signature to be in error.

Enumerator
PGPSUBTYPE_NONE | none
PGPSUBTYPE_SIG_CREATE_TIME | signature creation time
PGPSUBTYPE_SIG_EXPIRE_TIME | signature expiration time
PGPSUBTYPE_EXPORTABLE_CERT | exportable certification
PGPSUBTYPE_TRUST_SIG | trust signature
PGPSUBTYPE_REGEX | regular expression
PGPSUBTYPE_REVOCABLE | revocable
PGPSUBTYPE_KEY_EXPIRE_TIME | key expiration time
PGPSUBTYPE_ARR | additional recipient request
PGPSUBTYPE_PREFER_SYMKEY | preferred symmetric algorithms
PGPSUBTYPE_REVOKE_KEY | revocation key
PGPSUBTYPE_ISSUER_KEYID | issuer key ID
PGPSUBTYPE_NOTATION | notation data
PGPSUBTYPE_PREFER_HASH | preferred hash algorithms
PGPSUBTYPE_PREFER_COMPRESS | preferred compression algorithms
PGPSUBTYPE_KEYSERVER_PREFERS | key server preferences
PGPSUBTYPE_PREFER_KEYSERVER | preferred key server
PGPSUBTYPE_PRIMARY_USERID | primary user id
PGPSUBTYPE_POLICY_URL | policy URL
PGPSUBTYPE_KEY_FLAGS | key flags
PGPSUBTYPE_SIGNER_USERID | signer's user id
PGPSUBTYPE_REVOKE_REASON | reason for revocation
PGPSUBTYPE_FEATURES | feature flags (gpg)
PGPSUBTYPE_EMBEDDED_SIG | embedded signature (gpg)
PGPSUBTYPE_INTERNAL_100 | internal or user-defined
PGPSUBTYPE_INTERNAL_101 | internal or user-defined
PGPSUBTYPE_INTERNAL_102 | internal or user-defined
PGPSUBTYPE_INTERNAL_103 | internal or user-defined
PGPSUBTYPE_INTERNAL_104 | internal or user-defined
PGPSUBTYPE_INTERNAL_105 | internal or user-defined
PGPSUBTYPE_INTERNAL_106 | internal or user-defined
PGPSUBTYPE_INTERNAL_107 | internal or user-defined
PGPSUBTYPE_INTERNAL_108 | internal or user-defined
PGPSUBTYPE_INTERNAL_109 | internal or user-defined
PGPSUBTYPE_INTERNAL_110 | internal or user-defined
PGPSUBTYPE_CRITICAL | critical subpacket marker

Definition at line 396 of file rpmpgp.h.

enum pgpSymkeyAlgo_e

9.2.

Symmetric Key Algorithms

           ID           Algorithm
           --           ---------
           0          - Plaintext or unencrypted data
           1          - IDEA [IDEA]
           2          - Triple-DES (DES-EDE, as per spec -
                        168 bit key derived from 192)
           3          - CAST5 (128 bit key, as per RFC 2144)
           4          - Blowfish (128 bit key, 16 rounds) [BLOWFISH]
           5          - SAFER-SK128 (13 rounds) [SAFER]
           6          - Reserved for DES/SK
           7          - Reserved for AES with 128-bit key
           8          - Reserved for AES with 192-bit key
           9          - Reserved for AES with 256-bit key
           100 to 110 - Private/Experimental algorithm.

Implementations MUST implement Triple-DES. Implementations SHOULD implement IDEA and CAST5. Implementations MAY implement any other algorithm.

Enumerator
PGPSYMKEYALGO_PLAINTEXT | Plaintext
PGPSYMKEYALGO_IDEA | IDEA
PGPSYMKEYALGO_TRIPLE_DES | 3DES
PGPSYMKEYALGO_CAST5 | CAST5
PGPSYMKEYALGO_BLOWFISH | BLOWFISH
PGPSYMKEYALGO_SAFER | SAFER
PGPSYMKEYALGO_DES_SK | DES/SK
PGPSYMKEYALGO_AES_128 | AES(128-bit key)
PGPSYMKEYALGO_AES_192 | AES(192-bit key)
PGPSYMKEYALGO_AES_256 | AES(256-bit key)
PGPSYMKEYALGO_TWOFISH | TWOFISH(256-bit key)
PGPSYMKEYALGO_NOENCRYPT | no encryption

Definition at line 198 of file rpmpgp.h.

enum pgpTag_e

4.3.

Packet Tags

The packet tag denotes what type of packet the body holds. Note that old format headers can only have tags less than 16, whereas new format headers can have tags as great as 63.

Enumerator
PGPTAG_RESERVED | Reserved/Invalid
PGPTAG_PUBLIC_SESSION_KEY | Public-Key Encrypted Session Key
PGPTAG_SIGNATURE | Signature
PGPTAG_SYMMETRIC_SESSION_KEY | Symmetric-Key Encrypted Session Key
PGPTAG_ONEPASS_SIGNATURE | One-Pass Signature
PGPTAG_SECRET_KEY | Secret Key
PGPTAG_PUBLIC_KEY | Public Key
PGPTAG_SECRET_SUBKEY | Secret Subkey
PGPTAG_COMPRESSED_DATA | Compressed Data
PGPTAG_SYMMETRIC_DATA | Symmetrically Encrypted Data
PGPTAG_MARKER | Marker
PGPTAG_LITERAL_DATA | Literal Data
PGPTAG_TRUST | Trust
PGPTAG_USER_ID | User ID
PGPTAG_PUBLIC_SUBKEY | Public Subkey
PGPTAG_COMMENT_OLD | Comment (from OpenPGP draft)
PGPTAG_PHOTOID | PGP's photo ID
PGPTAG_ENCRYPTED_MDC | Integrity protected encrypted data
PGPTAG_MDC | Manipulaion detection code packet
PGPTAG_PRIVATE_60 | Private or Experimental Values
PGPTAG_COMMENT | Comment
PGPTAG_PRIVATE_62 | Private or Experimental Values
PGPTAG_CONTROL | Control (GPG)

Definition at line 46 of file rpmpgp.h.

enum pgpValType_e

Enumerator
PGPVAL_TAG |
PGPVAL_ARMORBLOCK |
PGPVAL_ARMORKEY |
PGPVAL_SIGTYPE |
PGPVAL_SUBTYPE |
PGPVAL_PUBKEYALGO |
PGPVAL_SYMKEYALGO |
PGPVAL_COMPRESSALGO |
PGPVAL_HASHALGO |
PGPVAL_SERVERPREFS |

Definition at line 917 of file rpmpgp.h.

enum rpmDigestFlags_e

Bit(s) to control digest operation.

Enumerator
RPMDIGEST_NONE |

Definition at line 933 of file rpmpgp.h.

## Function Documentation

char* pgpArmorWrap | ( | int | atype,
|  | const unsigned char * | s,
|  | size_t | ns
| ) |  |

Wrap a OpenPGP packets in ascii armor for transport.

Parameters

  atype | type of armor
  s | binary pkt data
  ns | binary pkt data length

Returns
  formatted string

Referenced by pgpGrab().

void pgpCleanDig | ( | pgpDig | dig | ) |

Release (malloc'd) data from container.

Parameters

  dig | container

Referenced by pgpGrab().

pgpDigParams pgpDigGetParams | ( | pgpDig | dig,
|  | unsigned int | pkttype
| ) |  |

Retrieve parameters for parsed OpenPGP packet(s).

Parameters

  dig | container
  pkttype | type of params to retrieve (signature / pubkey)

Returns
  pointer to OpenPGP parameters, NULL on error/not found

Referenced by pgpGrab().

unsigned int pgpDigParamsAlgo | ( | pgpDigParams | digp,
|  | unsigned int | algotype
| ) |  |

Retrieve OpenPGP algorithm parameters param digp parameter container param algotype PGPVAL_HASHALGO / PGPVAL_PUBKEYALGO return algorithm value, 0 on error.

Referenced by pgpGrab().

int pgpDigParamsCmp | ( | pgpDigParams | p1,
|  | pgpDigParams | p2
| ) |  |

Compare OpenPGP packet parameters param p1 1st parameter container param p2 2nd parameter container return 1 if the parameters differ, 0 otherwise.

Referenced by pgpGrab().

pgpDigParams pgpDigParamsFree | ( | pgpDigParams | digp | ) |

Destroy parsed OpenPGP packet parameter(s).

Parameters

  digp | parameter container

Returns
  NULL always

Referenced by pgpGrab().

int pgpExtractPubkeyFingerprint | ( | const char * | b64pkt,
|  | pgpKeyID_t | keyid
| ) |  |

Extract OpenPGP public key fingerprint from base64 encoded packet.

Todo:
  V3 non-RSA public keys not implemented.

Parameters

  b64pkt | base64 encoded openpgp packet

Return values

  keyid | public key fingerprint

Returns
  8 (no. of bytes) on success, < 0 on error

Referenced by pgpGrab().

pgpDig pgpFreeDig | ( | pgpDig | dig | ) |

Destroy a container for parsed OpenPGP packet(s).

Parameters

  dig | container

Returns
  NULL always

Referenced by pgpGrab().

static unsigned int pgpGrab | ( | const uint8_t * | s,
|  | size_t | nbytes
| ) |  |

inlinestatic

Return (native-endian) integer from big-endian representation.

Parameters

  s | pointer to big-endian integer
  nbytes | no. of bytes

Returns
  native-endian integer

Definition at line 954 of file rpmpgp.h.

References pgpPktPubkey_s::algo, pgpPktPubkey_s::keyid, pgpArmorWrap(), pgpCleanDig(), pgpDigGetParams(), pgpDigParamsAlgo(), pgpDigParamsCmp(), pgpDigParamsFree(), pgpExtractPubkeyFingerprint(), pgpFreeDig(), pgpHexStr(), pgpIdentItem(), pgpNewDig(), pgpParsePkts(), pgpPrtParams(), pgpPrtParamsSubkeys(), pgpPrtPkts(), pgpPubKeyCertLen(), pgpPubkeyFingerprint(), pgpReadPkts(), pgpVerifySig(), pgpVerifySignature(), rpmDigestBundleAdd(), rpmDigestBundleDupCtx(), rpmDigestBundleFinal(), rpmDigestBundleFree(), rpmDigestBundleNew(), rpmDigestBundleUpdate(), rpmDigestDup(), rpmDigestFinal(), rpmDigestInit(), rpmDigestLength(), rpmDigestUpdate(), rpmFreeCrypto(), and rpmInitCrypto().

char* pgpHexStr | ( | const uint8_t * | p,
|  | size_t | plen
| ) |  |

Return hex formatted representation of bytes.

Parameters

  p | bytes
  plen | no. of bytes

Returns
  hex formatted string (malloc'ed)

Referenced by pgpGrab().

char* pgpIdentItem | ( | pgpDigParams | digp | ) |

Return a string identification of a PGP signature/pubkey.

Parameters

  digp | signature/pubkey container

Returns
  string describing the item and parameters

Referenced by pgpGrab().

pgpDig pgpNewDig | ( | void |  | ) |

Create a container for parsed OpenPGP packet(s).

Returns
  container

Referenced by pgpGrab().

pgpArmor pgpParsePkts | ( | const char * | armor,
|  | uint8_t ** | pkt,
|  | size_t * | pktlen
| ) |  |

Parse armored OpenPGP packets from memory.

Parameters

  armor | armored OpenPGP packet string

Return values

  pkt | dearmored OpenPGP packet(s) (malloced)
  pktlen | dearmored OpenPGP packet(s) length in bytes

Returns
  type of armor found

Referenced by pgpGrab().

int pgpPrtParams | ( | const uint8_t * | pkts,
|  | size_t | pktlen,
|  | unsigned int | pkttype,
|  | pgpDigParams * | ret
| ) |  |

Parse a OpenPGP packet(s).

Parameters

  pkts | OpenPGP packet(s)
  pktlen | OpenPGP packet(s) length (no. of bytes)
  pkttype | Expected packet type (signature/key) or 0 for any

Return values

  ret | signature/pubkey packet parameters on success (alloced)

Returns
  -1 on error, 0 on success

Referenced by pgpGrab().

int pgpPrtParamsSubkeys | ( | const uint8_t * | pkts,
|  | size_t | pktlen,
|  | pgpDigParams | mainkey,
|  | pgpDigParams ** | subkeys,
|  | int * | subkeysCount
| ) |  |

Parse subkey parameters from OpenPGP packet(s).

Parameters

  pkts | OpenPGP packet(s)
  pktlen | OpenPGP packet(s) length (no. of bytes)
  mainkey | parameters of main key
  subkeys | array of subkey parameters (alloced)
  subkeysCount | count of subkeys

Returns
  -1 on error, 0 on success

Referenced by pgpGrab().

int pgpPrtPkts | ( | const uint8_t * | pkts,
|  | size_t | pktlen,
|  | pgpDig | dig,
|  | int | printing
| ) |  |

Print/parse a OpenPGP packet(s).

Parameters

  pkts | OpenPGP packet(s)
  pktlen | OpenPGP packet(s) length (no. of bytes)

Return values

  dig | parsed output of signature/pubkey packet parameters

Parameters

  printing | should packets be printed?

Returns
  -1 on error, 0 on success

Referenced by pgpGrab().

int pgpPubKeyCertLen | ( | const uint8_t * | pkts,
|  | size_t | pktslen,
|  | size_t * | certlen
| ) |  |

Return a length of the first public key certificate in a buffer given by pkts that contains one or more certificates.

A public key certificate consits of packets like Public key packet, User ID packet and so on. In a buffer every certificate starts with Public key packet and it ends with the start of the next certificate or with the end of the buffer.

Parameters

  pkts | pointer to a buffer with certificates
  pktslen | length of the buffer with certificates
  certlen | length of the first certificate in the buffer

Returns
  0 on success

Referenced by pgpGrab().

int pgpPubkeyFingerprint | ( | const uint8_t * | pkt,
|  | size_t | pktlen,
|  | pgpKeyID_t | keyid
| ) |  |

Calculate OpenPGP public key fingerprint.

Todo:
  V3 non-RSA public keys not implemented.

Parameters

  pkt | OpenPGP packet (i.e. PGPTAG_PUBLIC_KEY)
  pktlen | OpenPGP packet length (no. of bytes)

Return values

  keyid | public key fingerprint

Returns
  0 on success, else -1

Referenced by pgpGrab().

pgpArmor pgpReadPkts | ( | const char * | fn,
|  | uint8_t ** | pkt,
|  | size_t * | pktlen
| ) |  |

Parse armored OpenPGP packets from a file.

Parameters

  fn | file name

Return values

  pkt | dearmored OpenPGP packet(s) (malloced)
  pktlen | dearmored OpenPGP packet(s) length in bytes

Returns
  type of armor found

Referenced by pgpGrab().

const char* pgpValString | ( | pgpValType | type,
|  | uint8_t | val
| ) |  |

Return string representation of am OpenPGP value.

Parameters

  type | type of value
  val | byte value to lookup

Returns
  string value of byte

rpmRC pgpVerifySig | ( | pgpDig | dig,
|  | DIGEST_CTX | hashctx
| ) |  |

Verify a PGP signature.

Deprecated:
  use pgpVerifySignature() instead

Parameters

  dig | container
  hashctx | digest context

Returns
  RPMRC_OK on success

Referenced by pgpGrab().

rpmRC pgpVerifySignature | ( | pgpDigParams | key,
|  | pgpDigParams | sig,
|  | DIGEST_CTX | hashctx
| ) |  |

Verify a PGP signature.

Parameters

  key | public key
  sig | signature
  hashctx | digest context

Returns
  RPMRC_OK on success

Referenced by pgpGrab().

int rpmDigestBundleAdd | ( | rpmDigestBundle | bundle,
|  | int | algo,
|  | rpmDigestFlags | flags
| ) |  |

Add a new type of digest to a bundle.

Parameters

  bundle | digest bundle
  algo | type of digest
  flags | bit(s) to control digest operation

Returns
  0 on success

Referenced by pgpGrab().

DIGEST_CTX rpmDigestBundleDupCtx | ( | rpmDigestBundle | bundle,
|  | int | algo
| ) |  |

Duplicate a digest context from a bundle.

Parameters

  bundle | digest bundle
  algo | type of digest to dup

Returns
  duplicated digest context

Referenced by pgpGrab().

int rpmDigestBundleFinal | ( | rpmDigestBundle | bundle,
|  | int | algo,
|  | void ** | datap,
|  | size_t * | lenp,
|  | int | asAscii
| ) |  |

Return digest from a bundle and destroy context, see rpmDigestFinal().

Parameters

  bundle | digest bundle
  algo | type of digest to return

Return values

  datap | address of returned digest
  lenp | address of digest length

Parameters

  asAscii | return digest as ascii string?

Returns
  0 on success

Referenced by pgpGrab().

rpmDigestBundle rpmDigestBundleFree | ( | rpmDigestBundle | bundle | ) |

Free a digest bundle and all contained digest contexts.

Parameters

  bundle | digest bundle

Returns
  NULL always

Referenced by pgpGrab().

rpmDigestBundle rpmDigestBundleNew | ( | void |  | ) |

Create a new digest bundle.

Returns
  New digest bundle

Referenced by pgpGrab().

int rpmDigestBundleUpdate | ( | rpmDigestBundle | bundle,
|  | const void * | data,
|  | size_t | len
| ) |  |

Update contexts within bundle with next plain text buffer.

Parameters

  bundle | digest bundle
  data | next data buffer
  len | no. bytes of data

Returns
  0 on success

Referenced by pgpGrab().

DIGEST_CTX rpmDigestDup | ( | DIGEST_CTX | octx | ) |

Duplicate a digest context.

Parameters

  octx | existing digest context

Returns
  duplicated digest context

Referenced by pgpGrab().

int rpmDigestFinal | ( | DIGEST_CTX | ctx,
|  | void ** | datap,
|  | size_t * | lenp,
|  | int | asAscii
| ) |  |

Return digest and destroy context.

Final wrapup - pad to 64-byte boundary with the bit pattern 1 0* (64-bit count of bits processed, MSB-first)

Parameters

  ctx | digest context

Return values

  datap | address of returned digest
  lenp | address of digest length

Parameters

  asAscii | return digest as ascii string?

Returns
  0 on success

Referenced by pgpGrab().

DIGEST_CTX rpmDigestInit | ( | int | hashalgo,
|  | rpmDigestFlags | flags
| ) |  |

Initialize digest.

Set bit count to 0 and buffer to mysterious initialization constants.

Parameters

  hashalgo | type of digest
  flags | bit(s) to control digest operation

Returns
  digest context

Referenced by pgpGrab().

size_t rpmDigestLength | ( | int | hashalgo | ) |

Obtain digest length in bytes.

Parameters

  hashalgo | type of digest

Returns
  digest length, zero on invalid algorithm

Referenced by pgpGrab().

int rpmDigestUpdate | ( | DIGEST_CTX | ctx,
|  | const void * | data,
|  | size_t | len
| ) |  |

Update context with next plain text buffer.

Parameters

  ctx | digest context
  data | next data buffer
  len | no. bytes of data

Returns
  0 on success

Referenced by pgpGrab().

int rpmFreeCrypto | ( | void |  | ) |

Shutdown cryptography.

Referenced by pgpGrab().

int rpmInitCrypto | ( | void |  | ) |

Perform cryptography initialization.

It must be called before any cryptography can be used within rpm. It's not normally necessary to call it directly as it's called in general rpm initialization routines.

Returns
  0 on success, -1 on failure

Referenced by pgpGrab().